<template>
  <app-header>
    <button @click="$router.go(-1)">
      <v-icon color="white" aria-hidden="false"> mdi-chevron-left </v-icon>
    </button>
  </app-header>
  <div class="event">
    <v-snackbar v-model="join_error" color="error" :timeout="3000">
      Вы уже откликнулись на мероприятие!
    </v-snackbar>
    <template v-if="event">
      <app-modal
        title="Поздравляем!"
        @close="success_modal = false"
        v-if="success_modal"
      >
        <div class="modal-success">
          <p>Вы успешно откликнулись на мероприятие!</p>
          <v-btn
            color="blue"
            variant="contained-flat"
            size="large"
            @click="success_modal = false"
          >
            Принять
          </v-btn>
        </div>
      </app-modal>
      <app-modal
        title="Выбор роли"
        @close="show_join_modal = false"
        v-if="show_join_modal"
      >
        <div class="modal-roles">
          <div class="modal-roles__list">
            <div
              class="role-wrapper"
              v-for="role in event.roles"
              :key="role.id"
            >
              <div class="role">
                <div class="role-icon">
                  <v-icon color="white" size="16px">mdi-account</v-icon>
                </div>
                <p>{{ role.name }}</p>
              </div>
              <v-btn
                :color="select_role[0] === role.id ? 'error' : 'blue'"
                variant="contained-flat"
                size="small"
                @click="select_role = [role.id]"
              >
                {{ select_role[0] === role.id ? "Выбрано" : "Выбрать" }}
              </v-btn>
            </div>
          </div>
          <v-btn
            color="blue"
            variant="contained-flat"
            size="large"
            @click="joinWithRole"
            :disabled="!select_role"
          >
            Подтвердить
          </v-btn>
        </div>
      </app-modal>
      <div
        class="event-header"
        :style="{
          background: `url(${
            event.avatar
              ? event.avatar.url.full_size
              : require('../../assets/splash.svg')
          }) no-repeat center center`,
        }"
      >
        <span>{{ event.participants_count }} уч.</span>
        <h3>{{ event.title }}</h3>
      </div>
      <div class="event-actions">
        <div class="container">
          <v-btn
            color="blue"
            variant="contained-flat"
            size="large"
            @click="join"
          >
            Откликнуться
          </v-btn>
        </div>
      </div>
      <section>
        <div class="container">
          <h3>Описание</h3>
          <p>{{ event.description }}</p>
        </div>
      </section>
      <section v-if="event.roles.length">
        <div class="container">
          <h3>Набор ролей</h3>
          <div class="event-roles">
            <div class="role" v-for="role in event.roles" :key="role.id">
              <div class="role-icon">
                <v-icon color="white" size="16px">mdi-account</v-icon>
              </div>
              <p>{{ role.name }}</p>
            </div>
          </div>
        </div>
      </section>
      <section>
        <div class="container">
          <h3>Данные о событии</h3>
          <div class="event-data">
            <span v-if="event.place">
              <v-icon color="white">mdi-map-marker-outline</v-icon>
              {{ event.place }}
            </span>
            <span v-if="eventDate">
              <v-icon color="white">mdi-calendar-week</v-icon>
              {{ eventDate }}
            </span>
            <span v-if="event.min_age">
              <v-icon color="white">mdi-account-outline </v-icon>
              от {{ event.min_age }} лет
            </span>
            <span v-if="event.is_offline">
              <v-icon color="white">mdi-guy-fawkes-mask</v-icon>
              Офлайн
            </span>
            <span v-for="tag in event.tags" :key="tag.id">
              <v-icon color="white">mdi-menu</v-icon>
              {{ tag.name }}
            </span>
          </div>
        </div>
      </section>
      <section>
        <div class="container">
          <h3>Организатор</h3>
          <div class="event-organisation">
            <organisation-preview :organisation="event.organization" />
          </div>
        </div>
      </section>
      <section v-if="participants.length">
        <div class="container">
          <h3>Участники</h3>
          <div class="event-participants">
            <volunteer-preview
              v-for="volunteer in participants"
              :key="volunteer.id"
              :volunteer="volunteer"
            />
          </div>
        </div>
      </section>
    </template>
    <div class="event-loader" v-else>
      <app-loader label="Загружаем событие" />
    </div>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import OrganisationPreview from "@/components/OrganisationPreview";
import AppLoader from "@/components/AppLoader";
import AppHeader from "@/components/AppHeader";
import VolunteerPreview from "@/components/VolunteerPreview";
import moment from "moment";
import AppModal from "@/components/AppModal";

export default {
  name: "EventView",
  components: {
    AppModal,
    VolunteerPreview,
    AppHeader,
    AppLoader,
    OrganisationPreview,
  },
  data() {
    return {
      event: "",
      participants: "",
      join_error: false,
      show_join_modal: false,
      success_modal: false,
      select_role: "",
    };
  },

  computed: {
    eventDate() {
      return moment(this.event.start_at).format("DD.MM.YYYY HH:mm");
    },
  },

  methods: {
    ...mapActions({
      loadEventInfo: "events/loadEventInfo",
      loadEventParticipants: "events/loadEventParticipants",
      joinEvent: "events/joinEvent",
    }),

    join() {
      if (this.event.is_participant) {
        this.join_error = true;
        return;
      }

      if (this.event.roles.length) {
        this.show_join_modal = true;
        return;
      }

      this.joinToEvent();
    },

    joinToEvent() {
      this.joinEvent({ id: this.$route.params.id }).then(() => {
        this.success_modal = true;
        this.loadEventInfo(this.$route.params.id).then((response) => {
          this.event = response.data.data;
        });
        this.loadEventParticipants(this.$route.params.id).then((response) => {
          this.participants = response.data.data;
        });
      });
    },

    joinWithRole() {
      this.joinEvent({
        id: this.$route.params.id,
        role: this.select_role,
      }).then(() => {
        this.show_join_modal = false;
        this.success_modal = true;
        this.loadEventInfo(this.$route.params.id).then((response) => {
          this.event = response.data.data;
        });
        this.loadEventParticipants(this.$route.params.id).then((response) => {
          this.participants = response.data.data;
        });
      });
    },
  },

  mounted() {
    this.loadEventInfo(this.$route.params.id)
      .then((response) => {
        this.event = response.data.data;
      })
      .catch(() => {
        this.$router.push({ name: "Feed" });
      });
    this.loadEventParticipants(this.$route.params.id).then((response) => {
      this.participants = response.data.data;
    });
  },
};
</script>

<style scoped lang="scss">
.event {
  max-width: 425px;
  margin: 0 auto;
  padding: 0 0 64px;
  &-loader {
    margin: 45% 0 0;
    display: flex;
    align-items: center;
    justify-content: center;
  }
  &-header {
    width: 100%;
    height: 240px;
    background-size: cover !important;
    position: relative;
    &:after {
      content: "";
      width: 100%;
      height: 100%;
      display: block;
      background: linear-gradient(
        180deg,
        rgba(0, 0, 0, 0) 0%,
        rgba(0, 0, 0, 0.35) 100%
      );
      z-index: 2;
      left: 0;
      top: 0;
    }
    > span {
      position: absolute;
      padding: $base-space 10px;
      color: $white;
      font-weight: 400;
      font-size: 9px;
      line-height: 12px;
      top: $base-space * 4;
      right: $base-space * 4;
      background: $blue;
      border-radius: 4px;
    }
    > h3 {
      position: absolute;
      left: $base-space * 4;
      bottom: $base-space * 6;
      color: $white;
      font-weight: 600;
      font-size: 16px;
      line-height: 18px;
    }
  }
  &-actions {
    padding: ($base-space * 4) 0;
    > .container {
      display: flex;
      align-items: center;
      justify-content: center;
      > button {
        width: 95%;
      }
    }
  }

  &-data {
    display: flex;
    flex-wrap: wrap;
    justify-items: flex-start;
    align-items: flex-start;
    grid-gap: ($base-space * 2);
    > span {
      padding: ($base-space) ($base-space * 2);
      background: $blue;
      display: flex;
      align-items: center;
      justify-items: flex-start;
      border-radius: 12px;
      font-weight: 500;
      font-size: 12px;
      line-height: 20px;
      color: $white;
      > i {
        margin: 0 ($base-space) 0 0;
      }
      &:not(:last-child) {
        margin: 0 ($base-space * 2) 0 0;
      }
    }
  }

  > section {
    background: $white;
    padding: ($base-space * 4);
    margin: 0 0 ($base-space * 2);
    display: block;
    > .container {
      > h3 {
        font-style: normal;
        font-weight: 500;
        font-size: 14px;
        line-height: 18px;
        color: #5c5c5c;
        margin: 0 0 ($base-space * 2);
      }
      > p {
        font-style: normal;
        font-weight: 400;
        font-size: 14px;
        line-height: 18px;
        color: #5c5c5c;
      }
    }
  }

  &-organisation {
    > .organisation-preview {
      width: 100%;
    }
  }

  &-participants {
    width: 100%;
    display: flex;
    overflow-x: auto;
    flex-flow: row;
    grid-gap: $base-space * 2;
  }
  &-roles {
    width: 100%;
    display: flex;
    overflow-x: auto;
    flex-flow: row;
    grid-gap: $base-space * 2;
  }
}

.role {
  padding: 6px;
  border: 1px solid rgba(42, 49, 74, 0.2);
  border-radius: 10px;
  display: flex;
  align-items: center;
  justify-items: center;
  flex-flow: column;
  &-wrapper {
    display: flex;
    flex-flow: column;
    justify-content: center;
    align-items: center;
    > button {
      margin: $base-space 0 0;
    }
  }
  &-icon {
    width: 30px;
    height: 30px;
    background: $blue;
    display: flex;
    align-items: center;
    justify-content: center;
    border-radius: 10px;
    margin: 0 0 ($base-space * 2);
    > i {
      margin: 0;
      padding: 0;
    }
  }
  > p {
    font-weight: 400;
    font-size: 12px;
    line-height: 14px;
    text-align: center;
    letter-spacing: 0.0025em;
    color: rgba(0, 0, 0, 0.87);
  }
}

.modal {
  &-success {
    display: flex;
    flex-flow: column;
    justify-content: center;
    align-items: center;
    > p {
      text-align: center;
      margin: 0 0 $base-space * 4;
    }
  }
  &-roles {
    &__list {
      width: 100%;
      display: flex;
      overflow-x: auto;
      flex-flow: row;
      grid-gap: $base-space * 2;
      &::-webkit-scrollbar {
        display: none;
      }
      margin: 0 0 ($base-space * 8);
    }
    > button {
      width: 100%;
    }
  }
}
</style>
